//
//  ViewController.swift
//  Kalkulacka
//
//  Created by Tom on 11.03.2024.
//

import UIKit

class ViewController: UIViewController {

    
    @IBOutlet weak var Kalkulacka: UILabel!
    @IBOutlet weak var Vysledky: UILabel!
    
    var workings:String = ""
    
    override func viewDidLoad() {
        super.viewDidLoad()
        clearAll()
    }
    
    func clearAll()
    {
        workings = ""
        Kalkulacka.text = ""
        Vysledky.text = ""
    }

    @IBAction func Equals(_ sender: Any) {
        if(validInput())
        {
            let checkedWorkingsForPercent = workings.replacingOccurrences(of: "%", with: "*0.01")
            let expression = NSExpression(format: checkedWorkingsForPercent)
            let result = expression.expressionValue(with: nil, context: nil) as! Double
            let resultString = formatResult(result: result)
            Vysledky.text = resultString
        }
        else
        {
            let alert = UIAlertController(title: "Neznámá hodnota", message: "Kalkulačka nedokáže vypočítat vaše hodnoty", preferredStyle: .alert)
            alert.addAction(UIAlertAction(title: "Zavřít", style: .default))
            self.present(alert, animated: true, completion: nil)
        }
    }
    
    func validInput() ->Bool
    {
        var count = 0
        var funcCharIndexes = [Int]()
        
        for char in workings
        {
            if(specialCharacter(char: char))
            {
                funcCharIndexes.append(count)
            }
            count += 1
        }
        
        var previous: Int = -1
        
        for index in funcCharIndexes {
            if(index == 0)
            {
                return false
            }
            
            if(index == workings.count - 1)
            {
                return false
            }
            
            if (previous != -1)
            {
                if(index - previous == 1)
                {
                    return false
                }
            }
            previous = index
        }
        
        return true
    }
    
    func specialCharacter (char: Character) -> Bool
    {
        if(char == "*")
        {
            return true
        }
        if(char == "/")
        {
            return true
        }
        if(char == "+")
        {
            return true
        }
        return false
    }
    
    func formatResult(result: Double) -> String
    {
        if(result.truncatingRemainder(dividingBy: 1) == 0)
        {
            return String(format: "%.0f", result)
        }
        else
        {
            return String(format: "%.2f", result)
        }
    }
    
    @IBAction func Clear(_ sender: Any) {
        clearAll()
    }
    
    @IBAction func Back(_ sender: Any) {
        if(!workings.isEmpty)
        {
            workings.removeLast()
            Kalkulacka.text = workings
        }
    }
    
    func addToWorkings(value: String) {
        workings = workings + value
        Kalkulacka.text = workings
    }
    
    @IBAction func Procent(_ sender: Any) {
        addToWorkings(value: "%")
    }
    
    @IBAction func Divide(_ sender: Any) {
        addToWorkings(value: "/")
    }
    
    @IBAction func Times(_ sender: Any) {
        addToWorkings(value: "*")
    }
    
    @IBAction func Minus(_ sender: Any) {
        addToWorkings(value: "-")
    }
    
    @IBAction func Plus(_ sender: Any) {
        addToWorkings(value: "+")
    }
    
    @IBAction func Zero(_ sender: Any) {
        addToWorkings(value: "0")
    }
    
    @IBAction func Decimal(_ sender: Any) {
        addToWorkings(value: ".")
    }
    
    
    
    @IBAction func One(_ sender: Any) {
        addToWorkings(value: "1")
    }
    
    @IBAction func Two(_ sender: Any) {
        addToWorkings(value: "2")
    }
    
    @IBAction func Three(_ sender: Any) {
        addToWorkings(value: "3")
    }
    
    @IBAction func Four(_ sender: Any) {
        addToWorkings(value: "4")
    }
    
    @IBAction func Five(_ sender: Any) {
        addToWorkings(value: "5")
    }
    
    @IBAction func Six(_ sender: Any) {
        addToWorkings(value: "6")
    }
    
    @IBAction func Seven(_ sender: Any) {
        addToWorkings(value: "7")
    }
    
    @IBAction func Eight(_ sender: Any) {
        addToWorkings(value: "8")
    }
    
    @IBAction func Nine(_ sender: Any) {
        addToWorkings(value: "9")
    }
    
    
    
    
    
    
    
    
    
    
}

